<?php

namespace App\Http\Controllers\Yonetim;

use App\Http\Controllers\Controller;
use App\Models\Resimformat;
use App\Models\Servisler;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;
use Image;

class ServislerController extends Controller
{
    public function veriler(){
        $veriler = Servisler::latest()->get();

        return view('yonetim.servislerayar.servisler',compact('veriler'));
    }


    public function veriekle(){

        return view('yonetim.servislerayar.servisekle');
    }

    public function veriekleson(Request $request){



        $oturumyetki = Auth::user()->yetki;
        if ($oturumyetki==2 || $oturumyetki==1) {


            $resimbicimal=Resimformat::find(1);
            $resimtur=$resimbicimal->resimbicim;
            $resimkalite=$resimbicimal->resimkalite;

            $image = $request->file('resimyol');
            $name_gen = hexdec(uniqid()).'.'.$resimtur;
            Image::make($image)->fit(750, 450)->encode($resimtur, $resimkalite)->save('upload/servis/' . $name_gen);
            $save_url = 'upload/servis/'.$name_gen;



            Servisler::insert([

                'baslik' => $request->baslik,
                'slug' => Str::slug($request->baslik),
                'onaciklama' => $request->onaciklama,
                'aciklama' => $request->aciklama,
                'iconyol'=>$request->iconyol,
                'resimyol'=>$save_url,
                'updated_at' => Carbon::now(),

            ]);

            return redirect()->route('servisayar.all')->with('success','Hizmet Başarıyla Eklendi...');
        }else{
            return redirect()->back()->with('danger', 'İşlem Yetkiniz kısıtlı..');

        }





    }

    public function veriupdate($id){

        $veriler = Servisler::findOrFail($id);
        return view('yonetim.servislerayar.servisupdate',compact('veriler'));
    }

    public function veriupdateson(Request $request,$id){

        $oturumyetki = Auth::user()->yetki;
        if ($oturumyetki==2 || $oturumyetki==1) {

            if ($request->file('resimyol')) {

                $resimbicimal=Resimformat::find(1);
                $resimtur=$resimbicimal->resimbicim;
                $resimkalite=$resimbicimal->resimkalite;

                $image = $request->file('resimyol');
                $name_gen = hexdec(uniqid()).'.'.$resimtur;
                Image::make($image)->fit(750, 450)->encode($resimtur, $resimkalite)->save('upload/servis/' . $name_gen);
                $save_url = 'upload/servis/'.$name_gen;



                $eskiresimyol=$request->eskiresimyol;
                if (file_exists($eskiresimyol)){
                    unlink($eskiresimyol);

                }

                Servisler::findOrFail($id)->update([
                    'baslik' => $request->baslik,
                    'slug' => $request->slug,
                    'onaciklama' => $request->onaciklama,
                    'aciklama' => $request->aciklama,
                    'resimyol'=>$save_url,
                    'iconyol'=>$request->iconyol,
                    'durum'=>$request->durum,
                    'updated_at' => Carbon::now(),
                ]);


                return redirect()->back()->with('success', 'Hizmet Başarıyla Güncellendi...');

            }else{
                Servisler::findOrFail($id)->update([
                    'baslik' => $request->baslik,
                    'slug' => $request->slug,
                    'onaciklama' => $request->onaciklama,
                    'aciklama' => $request->aciklama,
                    'iconyol'=>$request->iconyol,
                    'durum'=>$request->durum,
                    'updated_at' => Carbon::now(),


                ]);


                return redirect()->back()->with('success', 'Hizmet Başarıyla Güncellendi...');

            }



        }else{
            return redirect()->back()->with('danger', 'İşlem Yetkiniz kısıtlı..');

        }


    }


    public function verisil($id){

        $oturumyetki = Auth::user()->yetki;
        if ($oturumyetki==2 || $oturumyetki==1) {
            $vericek = Servisler::findOrFail($id);
            $resimyol=$vericek->resimyol;

            if (file_exists($resimyol)){
                unlink($resimyol);

            }
            Servisler::findOrFail($id)->delete();
            return redirect()->back()->with('success', 'Silme İşlemi Başarılı..');

        }else{
            return redirect()->back()->with('danger', 'İşlem Yetkiniz kısıtlı..');

        }


    }

}
